import { Component, OnInit } from '@angular/core';
import { DataTemplateMeasureInfo, DataTemplateRenderInfo } from 'igniteui-angular-core';

@Component({
  selector: 'app-chart-page',
  templateUrl: './chart-page.component.html',
  styleUrls: ['./chart-page.component.scss']
})
export class ChartPageComponent implements OnInit {

  public data: any[] = [];

  constructor() { }

  ngOnInit(): void {
    this.data = [
      { Month: "JAN", Temperature:  3, MarkerPosition: 0  },
      { Month: "FEB", Temperature:  4, MarkerPosition: 0  },
      { Month: "MAR", Temperature:  9, MarkerPosition: 0  },
      { Month: "APR", Temperature: 15, MarkerPosition: 0  },
      { Month: "MAY", Temperature: 21, MarkerPosition: 0  },
      { Month: "JUN", Temperature: 26, MarkerPosition: 0  },
      { Month: "JUL", Temperature: 29, MarkerPosition: 0  },
      { Month: "AUG", Temperature: 28, MarkerPosition: 0  },
      { Month: "SEP", Temperature: 24, MarkerPosition: 0  },
      { Month: "OCT", Temperature: 18, MarkerPosition: 0  },
      { Month: "NOV", Temperature: 11, MarkerPosition: 0  },
      { Month: "DEC", Temperature:  5, MarkerPosition: 0  }
    ];
  }

  public seriesMouseLeftButtonDown(e: any){
    let item = e.args.item;
    console.log(item);
  }

  public getMarker(): any {
    return {
      measure: function (measureInfo: DataTemplateMeasureInfo) {
        const context = measureInfo.context;
        const height = context.measureText("M").height;
        const width = context.measureText("0.00").width;
        measureInfo.width = width;
        measureInfo.height = height;
      },
      render: function (renderInfo: DataTemplateRenderInfo) {
        let ctx = renderInfo.context;
        let x = renderInfo.xPosition;
        let y = renderInfo.yPosition;

        if (renderInfo.isHitTestRender) {
          ctx.fillStyle = renderInfo.data.actualItemBrush.fill;

          let width = renderInfo.availableWidth;
          let height = renderInfo.availableHeight;

          ctx.fillRect(x - (width / 2), y - (height), renderInfo.availableWidth, renderInfo.availableHeight);
          return;
        }

        const dataItem = renderInfo.data.item;
        if (dataItem === null) return;

        let dataValue = 0;
        dataValue = dataItem.Temperature;

        ctx.font = '8pt Verdana';
        ctx.textBaseline = 'top';
        ctx.fillStyle = "black";

        let xOffset = 20;
        let yOffset = 10;
        if (dataValue < 0) {
          ctx.fillText(dataValue, x - (xOffset / 2), y + (yOffset));
        }
        else {
          ctx.fillText(dataValue, x - (xOffset / 2), y - (yOffset * 2));
        }
      }
    }
  }
}
